/***********************************************************************************************************************
 *
 * blueBill Mobile - Android - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile
 * SCM: https://kenai.com/hg/bluebill~android-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.observation.impl;

import it.tidalwave.bluebill.mobile.observation.ui.ObservationItemRenderingOption.Builder;
import javax.annotation.Nonnull;
import java.util.Arrays;
import java.util.Collection;
import it.tidalwave.observation.ObservationItem;
import it.tidalwave.bluebill.mobile.observation.ui.ObservationItemRenderingOption;
import lombok.RequiredArgsConstructor;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@RequiredArgsConstructor
public abstract class ObservationItemTextRenderableSupport 
  {
    protected final @Nonnull ObservationItem observationItem;
    
    /*******************************************************************************************************************
     *
     *
     ******************************************************************************************************************/
    @Nonnull
    protected String renderArgs (final @Nonnull Object ... args)
      {
        final Collection<Object> extras = Arrays.asList(args);
        
        final Builder builder = new Builder();

        for (final Object arg : args)
          {
            if (arg instanceof ObservationItemRenderingOption)
              {
                ((ObservationItemRenderingOption)arg).render(builder, observationItem);                     
              }
          }

        String string = builder.asString();

        if (!"".equals(string))
          {
            string = " " + string;
          }
        
        return string;
      }
  }
