/***********************************************************************************************************************
 *
 * blueBill Mobile - Android - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile
 * SCM: https://kenai.com/hg/bluebill~android-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.taxonomy;

import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class TaxonomyDescription // TODO: merge with Taxonomy when you are able to do lazy taxa loading
  {
    @Nonnull
    private final String name;

    @Nonnull
    private final String id;

    @Nonnull
    private final String description;

    public TaxonomyDescription (final @Nonnull String id,
                                final @Nonnull String name,
                                final @Nonnull String description)
      {
        this.name = name;
        this.id = id;
        this.description = description;
      }

    @Nonnull
    public String getDescription()
      {
        return description;
      }

    @Nonnull
    public String getId()
      {
        return id;
      }

    @Nonnull
    public String getName()
      {
        return name;
      }
  }
