/***********************************************************************************************************************
 *
 * blueBill Mobile - Android - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile
 * SCM: https://kenai.com/hg/bluebill~android-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.taxonomy.factsheet;

import it.tidalwave.role.ui.PresentationModel;
import javax.annotation.Nonnull;
import java.util.List;
import it.tidalwave.mobile.ui.QuestionWithFeedback;

/***********************************************************************************************************************
 *
 * @stereotype View
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public interface TaxonFactSheetView
  {
    /*******************************************************************************************************************
     *
     * Renders the data.
     *
     ******************************************************************************************************************/
    public void populate (@Nonnull List<PresentationModel> presentationModels);
    
    /*******************************************************************************************************************
     *
     * 
     *
     ******************************************************************************************************************/
    public void notifyStatusChanged();

    /*******************************************************************************************************************
     *
     * Shows a confirmation that an operating was completed with success.
     * 
     * @param  message  the notification message
     *
     ******************************************************************************************************************/
    public void notifyCompletion (@Nonnull String message);
    
    /*******************************************************************************************************************
     *
     * Shows the notification that an operating caused an error.
     * 
     * @param  message  the notification message
     *
     ******************************************************************************************************************/
    public void notifyError (@Nonnull String message);
    
    /*******************************************************************************************************************
     *
     * Notifies that the SD card is not ready.
     * 
     * @param questionWithFeedback   the question and the feedback
     *
     ******************************************************************************************************************/
    public void notifySdCardNotReady (@Nonnull QuestionWithFeedback questionWithFeedback);

    /*******************************************************************************************************************
     *
     * Asks for confirmation to delete a media item.
     * 
     * @param questionWithFeedback   the question and the feedback
     *
     ******************************************************************************************************************/
    public void confirmToDeleteMedia (@Nonnull QuestionWithFeedback questionWithFeedback);

    /*******************************************************************************************************************
     *
     * Asks for confirmation to download a media item.
     * 
     * @param questionWithFeedback   the question and the feedback
     *
     ******************************************************************************************************************/
    public void confirmToDownloadMedia (@Nonnull QuestionWithFeedback questionWithFeedback);

    /*******************************************************************************************************************
     *
     * Opens a web page (typically related to a media item).
     * 
     * @param url  the URL
     *
     ******************************************************************************************************************/
    public void openWebPage (@Nonnull String url);
  }
